"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var fSpawnProxy = function spawnProxyFunction(options) {
    var path = this.path;
    var args = path.slice();
    var command = args.shift();
    var spawnee = child_process_1.spawn(command, args, options);
    var spawnPromise = new Promise(function (resolve, reject) {
        spawnee.once('exit', function (code, signal) {
            if (code === 0) {
                resolve();
                return;
            }
            reject(Object.assign(new Error('Spawn failed.'), { code: code, signal: signal }));
        });
    });
    spawnee.then = spawnPromise.then.bind(spawnPromise);
    return spawnee;
};
var pathWalker = {
    get: function (_a, arg) {
        var _b = (_a === void 0 ? {} : _a).path, _path = _b === void 0 ? [] : _b;
        var path = _path.concat([arg]);
        var oSpawnProxy = { path: path };
        var spawnProxy = Object.assign(fSpawnProxy.bind(oSpawnProxy), oSpawnProxy);
        return new Proxy(spawnProxy, pathWalker);
    },
};
exports.spawnProxy = new Proxy({}, pathWalker);
exports.default = exports.spawnProxy;
//# sourceMappingURL=spawn-proxy.js.map